var onloadHandler = function(event) {
	Ti.API.info("networkController onload OK");
	if (caller != null) {
		var newEvent={responseText: this.responseText};
		caller.fireEvent('update',newEvent);
		caller=null;
		db.complete(this.responseText);
	} else {
		Ti.API.info("networkController onload error");
	}
};

var onerrorHandler = function(event) {
	Ti.API.debug(event.error);
	alert('error');
};
var db=null;
var subscriber=0;
exports.networkController = function() {
		var Db=require('services/database').database;
		db=new Db();
		this.httpClient=Ti.Network.createHTTPClient({
			onload: onloadHandler,
			onerror: onerrorHandler,
			timeout:5000
		})
		subscriber++;
		Ti.API.info("NetworkController new:"+subscriber)
//	}
};
var callbackFn=null;
 exports.networkController.prototype.send = function(param,callback) {
	var url = "http://memento.alwaysdata.net/utpa/utpart.php?"+param;
	callbackFn=callback;
	var foundResult=db.find(param);
	if (foundResult) {
		var event={responseText: foundResult};
 		callback(event);
		return false;
	 } else {
		db.push(param,"pending");
		this.httpClient.open("GET", url);
		this.httpClient.send(); // request is actually sent with this statement
		return true;
	 }
 }
 var caller=null;
exports.networkController.prototype.send2 = function(param,thiz) {
	var url = "http://memento.alwaysdata.net/utpa/utpart.php?"+param;
	caller=thiz;
	var foundResult=db.find(param);
	if (foundResult) {
		Ti.API.info("NetworkController send (cached)");
		var event={responseText: foundResult};
//		event.source.responseText=foundResult;
		thiz.fireEvent('update',event);
		caller=null;
		return false;
	} else {
		Ti.API.info("NetworkController send (new)");
		db.push(param,"pending");
		this.httpClient.open("GET", url);
		this.httpClient.send(); // request is actually sent with this statement
		return true;
	}
}

