var valueObject=null;
var selectedIndex=0;
var selectedPage=0;
var tabViews=null;
var maxItem=0;
var scrollEvent=false;

function UI_ViewArtistes(data,index) {
	valueObject=data;
	selectedIndex=index;
	var ArtisteUI=require('ui/artiste');
	var artiste1=new ArtisteUI();
	var artiste2=new ArtisteUI();
	var artiste3=new ArtisteUI();
	maxItem=data.length;
	tabViews=new Array(artiste1,artiste2,artiste3);
	if (index>0) {
		if (index<data.length-1) {
			selectedPage=1;
			artiste1.dataChange(data[index-1]);
			artiste2.dataChange(data[index]);
			artiste3.dataChange(data[index+1]);
		} else {
			selectedPage=2;
			artiste1.dataChange(data[index-2]);
			artiste2.dataChange(data[index-1]);
			artiste3.dataChange(data[index]);
		}
	} else {
		selectedPage=0;
		artiste1.dataChange(data[index]);
		artiste2.dataChange(data[index+1]);
		artiste3.dataChange(data[index+2]);
	}
	
	this.ui = Titanium.UI.createScrollableView({
		width:Ti.Platform.displayCaps.platformWidth,
		height:'100%',//Ti.App.Properties.getInt('winHeight'),
		views:[artiste1.getUi(),artiste2.getUi(),artiste3.getUi()],
		touchEnabled:true,
		currentPage : selectedPage,
		cacheSize:3
	}); 
	initDone=false;
	this.ui.addEventListener('scrollEnd',viewScroll2);
}

UI_ViewArtistes.prototype.getUi = function () {
	return this.ui;
}

var scrollViewCopy = function(views,from, to) {
		views[to].children[0].text=views[from].children[0].text;
		views[to].children[1].text=views[from].children[1].text;
		views[to].children[2].image=views[from].children[2].image;
		views[to].children[3].value=views[from].children[3].value;
        views[from].setContentOffset({x:0,y:0}); //, {animated:false});
        views[to].setContentOffset({x:0,y:0}); //, {animated:false});
}

var viewScrollEvent= function(event) {

	if ((this.toString() == '[object TiUIScrollView]') &&(this===tabViews[0].ui)) {
		var offset=this.contentOffset.y;
		Ti.API.info("scrollView offset views[0] :"+this.children[0].text+" y:"+this.contentOffset.y);
		if (offset!=0) {
			this.setContentOffset({x:0,y:0});//, {animated:false});
			Ti.API.info("scrollView cleared views[0] y:"+this.contentOffset.y);
		} 
	} 
}
var viewScroll2 = function(event) {
    Ti.API.info("End scroll2 event page:"+event.currentPage);
 	var offsetY;
    switch(event.currentPage) {
        case 0 : 
                
               if (selectedIndex>1) {
					// remove scroll event listener if any
					if (scrollEvent) {
						this.views[0].removeEventListener('scroll',viewScrollEvent);
						scrollEvent=false;
						Ti.API.info("VIEW ARTISTES removeEventListener");
					}
                	selectedIndex--;
					Ti.API.info("VIEW ARTISTES SCROLL Down dataChange:"+selectedIndex);
                    var vw = this.views[2];
                    // keep view related object reference
                    var temp=tabViews[2];
                    tabViews[2] = tabViews[1]; 
                    tabViews[1] = tabViews[0];
					this.removeView(vw); // if commented, have to manage some scroll event
					// test 1 : try to copy view0 content to view1 before setViews
	                //  scrollViewCopy(this.views,0,1);
                    
                    // update view0 with new data
                    temp.dataChange(valueObject[selectedIndex-1]);
                    tabViews[0]=temp;
                    this.views = [tabViews[0].getUi(),tabViews[1].getUi(),tabViews[2].getUi()];
                    this.currentPage=1;
                    
                    // test 2 : to clear eventual contentOffset 
                    // this.views[0].setContentOffset({x:0,y:0}, {animated:false});
                    
                    // test 3 : try to handle scroll event to clear eventual contentOffset 
					// this.views[0].addEventListener('scroll',viewScrollEvent);
					// scrollEvent=true;
               } 
               break;
        case 1 :
					Ti.API.info("VIEW ARTISTES SCROLL middle:"+selectedIndex);
                break;
        case 2 : 
                ;
                if (selectedIndex<maxItem-2) {
					// remove scroll event listener if any
					if (scrollEvent) {
						this.views[0].removeEventListener('scroll',viewScrollEvent);
						scrollEvent=false;
						Ti.API.info("VIEW ARTISTES removeEventListener");
					}
                    selectedIndex++
					Ti.API.info("VIEW ARTISTES SCROLL UP dataChange:"+selectedIndex);
                    var vw = this.views[0];
                    var temp=tabViews[0];
                    tabViews[0] = tabViews[1];
                    tabViews[1] = tabViews[2];
                    this.removeView(vw);
                    temp.dataChange(valueObject[selectedIndex+1]);
                    tabViews[2] = temp;
                    this.currentPage = 1;
                    this.views = [tabViews[0].getUi(),tabViews[1].getUi(),tabViews[2].getUi()];
                }
                break;
    }
 
}

module.exports=UI_ViewArtistes;